<html>
<head>
<title>OGRE: OgreShadowCaster.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.5.3 -->
<div class="tabs">
  <ul>
    <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
    <li><a href="namespaces.html"><span>Namespaces</span></a></li>
    <li><a href="classes.html"><span>Classes</span></a></li>
    <li class="current"><a href="files.html"><span>Files</span></a></li>
    <li><a href="dirs.html"><span>Directories</span></a></li>
    <li><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
  </ul>
</div>
<div class="nav">
<a class="el" href="dir_d6c9b501d36b850bf0bac687671293db.html">OgreMain</a>&nbsp;&raquo&nbsp;<a class="el" href="dir_f35e1e76cd4423745a1cccb1f171d4e3.html">include</a></div>
<h1>OgreShadowCaster.h</h1><a href="OgreShadowCaster_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">    (Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2006 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment">Also see acknowledgements in Readme.html</span>
<a name="l00009"></a>00009 <span class="comment"></span>
<a name="l00010"></a>00010 <span class="comment">This program is free software; you can redistribute it and/or modify it under</span>
<a name="l00011"></a>00011 <span class="comment">the terms of the GNU Lesser General Public License as published by the Free Software</span>
<a name="l00012"></a>00012 <span class="comment">Foundation; either version 2 of the License, or (at your option) any later</span>
<a name="l00013"></a>00013 <span class="comment">version.</span>
<a name="l00014"></a>00014 <span class="comment"></span>
<a name="l00015"></a>00015 <span class="comment">This program is distributed in the hope that it will be useful, but WITHOUT</span>
<a name="l00016"></a>00016 <span class="comment">ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS</span>
<a name="l00017"></a>00017 <span class="comment">FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">You should have received a copy of the GNU Lesser General Public License along with</span>
<a name="l00020"></a>00020 <span class="comment">this program; if not, write to the Free Software Foundation, Inc., 59 Temple</span>
<a name="l00021"></a>00021 <span class="comment">Place - Suite 330, Boston, MA 02111-1307, USA, or go to</span>
<a name="l00022"></a>00022 <span class="comment">http://www.gnu.org/copyleft/lesser.txt.</span>
<a name="l00023"></a>00023 <span class="comment"></span>
<a name="l00024"></a>00024 <span class="comment">You may alternatively use this source under the terms of a specific version of</span>
<a name="l00025"></a>00025 <span class="comment">the OGRE Unrestricted License provided you have obtained such a license from</span>
<a name="l00026"></a>00026 <span class="comment">Torus Knot Software Ltd.</span>
<a name="l00027"></a>00027 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00028"></a>00028 <span class="comment">*/</span>
<a name="l00029"></a>00029 <span class="preprocessor">#ifndef __ShadowCaster_H__</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span><span class="preprocessor">#define __ShadowCaster_H__</span>
<a name="l00031"></a>00031 <span class="preprocessor"></span>
<a name="l00032"></a>00032 <span class="preprocessor">#include "<a class="code" href="OgrePrerequisites_8h.html">OgrePrerequisites.h</a>"</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include "<a class="code" href="OgreRenderable_8h.html">OgreRenderable.h</a>"</span>
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 <span class="keyword">namespace </span>Ogre {
<a name="l00037"></a>00037 
<a name="l00038"></a>00038 
<a name="l00047"></a><a class="code" href="classOgre_1_1ShadowRenderable.html">00047</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1ShadowRenderable.html" title="Class which represents the renderable aspects of a set of shadow volume faces.">ShadowRenderable</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1Renderable.html" title="Abstract class defining the interface all renderable objects must implement.">Renderable</a>
<a name="l00048"></a>00048     {
<a name="l00049"></a>00049     <span class="keyword">protected</span>:
<a name="l00050"></a><a class="code" href="classOgre_1_1ShadowRenderable.html#8c86d49c8c295f71ee409d1b20e5854d">00050</a>         <a class="code" href="classOgre_1_1MaterialPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to MaterialPtr.">MaterialPtr</a> mMaterial;
<a name="l00051"></a><a class="code" href="classOgre_1_1ShadowRenderable.html#a88e6ce3da25b3ea5a2fc5e622798b37">00051</a>         <a class="code" href="classOgre_1_1RenderOperation.html" title="&amp;#39;New&amp;#39; rendering operation using vertex buffers.">RenderOperation</a> mRenderOp;
<a name="l00052"></a><a class="code" href="classOgre_1_1ShadowRenderable.html#c5e870a708a1fcc9fa8d6873aa11f5c1">00052</a>         <a class="code" href="classOgre_1_1ShadowRenderable.html" title="Class which represents the renderable aspects of a set of shadow volume faces.">ShadowRenderable</a>* mLightCap; <span class="comment">// used only if isLightCapSeparate == true</span>
<a name="l00053"></a>00053     <span class="keyword">public</span>:
<a name="l00054"></a><a class="code" href="classOgre_1_1ShadowRenderable.html#fd48548fe3314d5d419c695c0788b278">00054</a>         <a class="code" href="classOgre_1_1ShadowRenderable.html" title="Class which represents the renderable aspects of a set of shadow volume faces.">ShadowRenderable</a>() : mMaterial(), mLightCap(0) {}
<a name="l00055"></a><a class="code" href="classOgre_1_1ShadowRenderable.html#3b9d5d4abdc4158e035c174816748305">00055</a>         <span class="keyword">virtual</span> ~<a class="code" href="classOgre_1_1ShadowRenderable.html" title="Class which represents the renderable aspects of a set of shadow volume faces.">ShadowRenderable</a>() { <span class="keyword">delete</span> mLightCap; }
<a name="l00059"></a><a class="code" href="classOgre_1_1ShadowRenderable.html#624c5d9e88df9caeb2f7d57e69dab2be">00059</a>         <span class="keywordtype">void</span> setMaterial(<span class="keyword">const</span> <a class="code" href="classOgre_1_1MaterialPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to MaterialPtr.">MaterialPtr</a>&amp; mat) { mMaterial = mat; }
<a name="l00061"></a><a class="code" href="classOgre_1_1ShadowRenderable.html#f314cc202a2b7c3dcf4dd3dc9432346e">00061</a>         <span class="keyword">const</span> <a class="code" href="classOgre_1_1MaterialPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to MaterialPtr.">MaterialPtr</a>&amp; getMaterial(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mMaterial; }
<a name="l00063"></a><a class="code" href="classOgre_1_1ShadowRenderable.html#36d3d1a31ec2661d66faa4675391ed25">00063</a>         <span class="keywordtype">void</span> getRenderOperation(<a class="code" href="classOgre_1_1RenderOperation.html" title="&amp;#39;New&amp;#39; rendering operation using vertex buffers.">RenderOperation</a>&amp; op) { op = mRenderOp; }
<a name="l00065"></a><a class="code" href="classOgre_1_1ShadowRenderable.html#e192ff33315f05bee1865a64547fe9a2">00065</a>         <a class="code" href="classOgre_1_1RenderOperation.html" title="&amp;#39;New&amp;#39; rendering operation using vertex buffers.">RenderOperation</a>* getRenderOperationForUpdate(<span class="keywordtype">void</span>) {<span class="keywordflow">return</span> &amp;mRenderOp;}
<a name="l00067"></a>00067         <span class="keywordtype">void</span> getWorldTransforms(<a class="code" href="classOgre_1_1Matrix4.html" title="Class encapsulating a standard 4x4 homogenous matrix.">Matrix4</a>* xform) <span class="keyword">const</span> = 0;
<a name="l00069"></a>00069         <span class="keyword">const</span> <a class="code" href="classOgre_1_1Quaternion.html" title="Implementation of a Quaternion, i.e.">Quaternion</a>&amp; getWorldOrientation(<span class="keywordtype">void</span>) <span class="keyword">const</span> = 0;
<a name="l00071"></a>00071         <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; getWorldPosition(<span class="keywordtype">void</span>) <span class="keyword">const</span> = 0;
<a name="l00073"></a><a class="code" href="classOgre_1_1ShadowRenderable.html#0095fe3c8590580bb2b2176e5f279615">00073</a>         <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> getSquaredViewDepth(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Camera.html" title="A viewpoint from which the scene will be rendered.">Camera</a>*)<span class="keyword"> const</span>{ <span class="keywordflow">return</span> 0; <span class="comment">/* not used */</span>}
<a name="l00075"></a>00075         <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#b82c6299605910b4051ebb3cc3e5539e">LightList</a>&amp; getLights(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00086"></a><a class="code" href="classOgre_1_1ShadowRenderable.html#46225aeba80348f0a48b73fb1667866d">00086</a>         <span class="keywordtype">bool</span> isLightCapSeparate(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mLightCap != 0; }
<a name="l00087"></a>00087 
<a name="l00089"></a><a class="code" href="classOgre_1_1ShadowRenderable.html#9039657d8484c4c1d5bc249aa4bce723">00089</a>         <a class="code" href="classOgre_1_1ShadowRenderable.html" title="Class which represents the renderable aspects of a set of shadow volume faces.">ShadowRenderable</a>* getLightCapRenderable(<span class="keywordtype">void</span>) { <span class="keywordflow">return</span> mLightCap; }
<a name="l00091"></a><a class="code" href="classOgre_1_1ShadowRenderable.html#e3bb22e06004a85619a71255367dd72f">00091</a>         <span class="keyword">virtual</span> <span class="keywordtype">bool</span> isVisible(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <span class="keyword">true</span>; }
<a name="l00092"></a>00092 
<a name="l00093"></a>00093     };
<a name="l00094"></a>00094 
<a name="l00096"></a><a class="code" href="namespaceOgre.html#5422f3d75ddc606ee01f69d14e37a8cc">00096</a>     <span class="keyword">enum</span> <a class="code" href="namespaceOgre.html#5422f3d75ddc606ee01f69d14e37a8cc" title="A set of flags that can be used to influence ShadowRenderable creation.">ShadowRenderableFlags</a>
<a name="l00097"></a>00097     {
<a name="l00099"></a><a class="code" href="namespaceOgre.html#5422f3d75ddc606ee01f69d14e37a8cc42b7242b2403601a94289579c0484b7e">00099</a>         <a class="code" href="namespaceOgre.html#5422f3d75ddc606ee01f69d14e37a8cc42b7242b2403601a94289579c0484b7e" title="For shadow volume techniques only, generate a light cap on the volume.">SRF_INCLUDE_LIGHT_CAP</a> = 0x00000001,
<a name="l00101"></a><a class="code" href="namespaceOgre.html#5422f3d75ddc606ee01f69d14e37a8cc33f01b987b6a184a90c99533cc257992">00101</a>         <a class="code" href="namespaceOgre.html#5422f3d75ddc606ee01f69d14e37a8cc33f01b987b6a184a90c99533cc257992" title="For shadow volume techniques only, generate a dark cap on the volume.">SRF_INCLUDE_DARK_CAP</a>  = 0x00000002,
<a name="l00103"></a><a class="code" href="namespaceOgre.html#5422f3d75ddc606ee01f69d14e37a8cccb424293924baf3e1b2bb29041270fec">00103</a>         <a class="code" href="namespaceOgre.html#5422f3d75ddc606ee01f69d14e37a8cccb424293924baf3e1b2bb29041270fec" title="For shadow volume techniques only, indicates volume is extruded to infinity.">SRF_EXTRUDE_TO_INFINITY</a>  = 0x00000004
<a name="l00104"></a>00104     };
<a name="l00105"></a>00105 
<a name="l00108"></a><a class="code" href="classOgre_1_1ShadowCaster.html">00108</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1ShadowCaster.html" title="This class defines the interface that must be implemented by shadow casters.">ShadowCaster</a>
<a name="l00109"></a>00109     {
<a name="l00110"></a>00110     <span class="keyword">public</span>:
<a name="l00111"></a><a class="code" href="classOgre_1_1ShadowCaster.html#a09c6e22f9879c123355bca19c1b7131">00111</a>         <span class="keyword">virtual</span> ~<a class="code" href="classOgre_1_1ShadowCaster.html" title="This class defines the interface that must be implemented by shadow casters.">ShadowCaster</a>() { }
<a name="l00113"></a>00113         <span class="keyword">virtual</span> <span class="keywordtype">bool</span> getCastShadows(<span class="keywordtype">void</span>) <span class="keyword">const</span> = 0;
<a name="l00114"></a>00114 
<a name="l00116"></a>00116         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1EdgeData.html" title="This class contains the information required to describe the edge connectivity of...">EdgeData</a>* getEdgeList(<span class="keywordtype">void</span>) = 0;
<a name="l00118"></a>00118         <span class="keyword">virtual</span> <span class="keywordtype">bool</span> hasEdgeList(<span class="keywordtype">void</span>) = 0;
<a name="l00119"></a>00119 
<a name="l00121"></a>00121         <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="classOgre_1_1AxisAlignedBox.html" title="A 3D box aligned with the x/y/z axes.">AxisAlignedBox</a>&amp; getWorldBoundingBox(<span class="keywordtype">bool</span> derive = <span class="keyword">false</span>) <span class="keyword">const</span> = 0;
<a name="l00123"></a>00123         <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="classOgre_1_1AxisAlignedBox.html" title="A 3D box aligned with the x/y/z axes.">AxisAlignedBox</a>&amp; getLightCapBounds(<span class="keywordtype">void</span>) <span class="keyword">const</span> = 0;
<a name="l00125"></a>00125         <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="classOgre_1_1AxisAlignedBox.html" title="A 3D box aligned with the x/y/z axes.">AxisAlignedBox</a>&amp; getDarkCapBounds(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Light.html" title="Representation of a dynamic light source in the scene.">Light</a>&amp; light, <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> dirLightExtrusionDist) <span class="keyword">const</span> = 0;
<a name="l00126"></a>00126 
<a name="l00127"></a><a class="code" href="classOgre_1_1ShadowCaster.html#c7b3777c0e3521c021ec3a1c2c444039">00127</a>         <span class="keyword">typedef</span> std::vector&lt;ShadowRenderable*&gt; ShadowRenderableList;
<a name="l00128"></a><a class="code" href="classOgre_1_1ShadowCaster.html#7b0999d33e25db97d0449d6cf95cbecd">00128</a>         <span class="keyword">typedef</span> <a class="code" href="classOgre_1_1VectorIterator.html" title="Wraps iteration over a vector.">VectorIterator&lt;ShadowRenderableList&gt;</a> <a class="code" href="classOgre_1_1VectorIterator.html" title="Wraps iteration over a vector.">ShadowRenderableListIterator</a>;
<a name="l00129"></a>00129 
<a name="l00145"></a>00145         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1VectorIterator.html" title="Wraps iteration over a vector.">ShadowRenderableListIterator</a> getShadowVolumeRenderableIterator(
<a name="l00146"></a>00146             <a class="code" href="namespaceOgre.html#79dcd426d291c31072c1ad6f183715d6" title="An enumeration of broad shadow techniques.">ShadowTechnique</a> shadowTechnique, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Light.html" title="Representation of a dynamic light source in the scene.">Light</a>* light, 
<a name="l00147"></a>00147             <a class="code" href="classOgre_1_1HardwareIndexBufferSharedPtr.html" title="Shared pointer implementation used to share index buffers.">HardwareIndexBufferSharedPtr</a>* indexBuffer, 
<a name="l00148"></a>00148             <span class="keywordtype">bool</span> extrudeVertices, <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> extrusionDistance, <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> flags = 0 ) = 0;
<a name="l00149"></a>00149 
<a name="l00169"></a>00169         <span class="keyword">static</span> <span class="keywordtype">void</span> extrudeVertices(<span class="keyword">const</span> <a class="code" href="classOgre_1_1HardwareVertexBufferSharedPtr.html" title="Shared pointer implementation used to share index buffers.">HardwareVertexBufferSharedPtr</a>&amp; vertexBuffer, 
<a name="l00170"></a>00170             <span class="keywordtype">size_t</span> originalVertexCount, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector4.html" title="4-dimensional homogenous vector.">Vector4</a>&amp; lightPos, <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> extrudeDist);
<a name="l00172"></a>00172         <span class="keyword">virtual</span> <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> getPointExtrusionDistance(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Light.html" title="Representation of a dynamic light source in the scene.">Light</a>* l) <span class="keyword">const</span> = 0;
<a name="l00173"></a>00173     <span class="keyword">protected</span>:
<a name="l00175"></a>00175         <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> getExtrusionDistance(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; objectPos, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Light.html" title="Representation of a dynamic light source in the scene.">Light</a>* light) <span class="keyword">const</span>;
<a name="l00183"></a>00183         <span class="keyword">virtual</span> <span class="keywordtype">void</span> updateEdgeListLightFacing(<a class="code" href="classOgre_1_1EdgeData.html" title="This class contains the information required to describe the edge connectivity of...">EdgeData</a>* edgeData, 
<a name="l00184"></a>00184             <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector4.html" title="4-dimensional homogenous vector.">Vector4</a>&amp; lightPos);
<a name="l00185"></a>00185 
<a name="l00199"></a>00199         <span class="keyword">virtual</span> <span class="keywordtype">void</span> generateShadowVolume(<a class="code" href="classOgre_1_1EdgeData.html" title="This class contains the information required to describe the edge connectivity of...">EdgeData</a>* edgeData, 
<a name="l00200"></a>00200             <span class="keyword">const</span> <a class="code" href="classOgre_1_1HardwareIndexBufferSharedPtr.html" title="Shared pointer implementation used to share index buffers.">HardwareIndexBufferSharedPtr</a>&amp; indexBuffer, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Light.html" title="Representation of a dynamic light source in the scene.">Light</a>* light,
<a name="l00201"></a>00201             ShadowRenderableList&amp; shadowRenderables, <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> flags);
<a name="l00208"></a>00208         <span class="keyword">virtual</span> <span class="keywordtype">void</span> extrudeBounds(<a class="code" href="classOgre_1_1AxisAlignedBox.html" title="A 3D box aligned with the x/y/z axes.">AxisAlignedBox</a>&amp; box, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector4.html" title="4-dimensional homogenous vector.">Vector4</a>&amp; lightPos, 
<a name="l00209"></a>00209             <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> extrudeDist) <span class="keyword">const</span>;
<a name="l00210"></a>00210 
<a name="l00211"></a>00211 
<a name="l00212"></a>00212     };
<a name="l00213"></a>00213 }
<a name="l00214"></a>00214 
<a name="l00215"></a>00215 <span class="preprocessor">#endif</span>
</pre></div><hr>
<p>
Copyright &copy; 2000-2005 by The OGRE Team<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/2.5/"><img alt="Creative Commons License" border="0" src="http://creativecommons.org/images/public/somerights20.png"/></a><br/>
This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/2.5/">Creative Commons Attribution-ShareAlike 2.5 License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Mon Jun 16 12:48:56 2008
</p>
</body>
</html>
